import argparse
import socket
import struct
import sys

if not hasattr(socket, 'SO_BINDTODEVICE'):
    socket.SO_BINDTODEVICE = 25

parser = argparse.ArgumentParser()
parser.add_argument("multicast_group", help="Multicast IPv6 to use for subscription")

args = parser.parse_args()
server_address = ('', 10000)

sock = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM)
sock.bind(server_address)

# on all interfaces.
sock.setsockopt(socket.IPPROTO_IPV6, socket.IPV6_JOIN_GROUP, socket.inet_pton(socket.AF_INET6, args.multicast_group) + struct.pack('@I', 0))

try:
    while True:
        data, address = sock.recvfrom(10240)
        print(data.decode("utf-8"))
finally:
    sock.close()
