import argparse
import socket
import struct
import traceback

parser = argparse.ArgumentParser()
parser.add_argument("addr", help="IPv6 address to use for source")
parser.add_argument("multicast_group", help="Multicast IPv6 address to use for destination")

args = parser.parse_args()
print(args.addr)
print(args.multicast_group)

ttl = 12
sock = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM)
sock.setsockopt(socket.IPPROTO_IPV6, socket.IPV6_MULTICAST_HOPS, ttl)

sock.bind((args.addr, 10000))
try:
    while True:
        input_msg = input('msg --> ')
        try:
            sock.sendto(input_msg.encode("utf-8"), (args.multicast_group, 10000))
        except Exception:
            traceback.print_exc()
            continue

finally:
    sock.close()
